#pragma once

// Sandbox flags
#define	SANDBOXFLAGS_PASSTHROUGH		1
#define	SANDBOXFLAGS_COPY_ON_WRITE		2
#define	SANDBOXFLAGS_FULL_ISOLATION		3

// API return codes
#define APIRET_SUCCESS					0
#define APIRET_FAILURE					1
#define APIRET_VIRTFILES_DB_ERROR		2
#define APIRET_VIRTFILES_ZIP_ERROR		3
#define APIRET_NOT_FOUND				5
#define APIRET_INVALID_PARAMETER		6
#define APIRET_FILE_CREATE_ERROR		7
#define APIRET_PE_RESOURCE_ERROR		8
#define APIRET_MEMORY_ERROR				9
#define APIRET_COMMIT_ERROR				10
#define APIRET_VIRTREG_DEPLOY_ERROR		11
#define APIRET_OUTPUT_ERROR				12
#define APIRET_INSUFFICIENT_BUFFER		13
#define APIRET_LOADLIBRARY_ERROR		14
#define APIRET_VIRTFILES_INI_ERROR		15
#define APIRET_APP_NOT_DEPLOYED			16
#define APIRET_INSUFFICIENT_PRIVILEGES	17
#define APIRET_32_64_BIT_MISMATCH		18
#define APIRET_DOTNET_REQUIRED			19
#define APIRET_CANCELLED				20
#define APIRET_INJECTION_FAILED			21

// VirtFilesDb flags
#define VIRT_FILE_FLAGS_ISFILE			0x0001	// File or directory?
#define VIRT_FILE_FLAGS_DELETED			0x0002	// Deleted by virtual app (NOT_FOUND)
#define VIRT_FILE_FLAGS_DEPLOYED		0x0008	// Set upon first file opening
// 0x10 is reserved
#define VIRT_FILE_FLAGS_PKG_FILE		0x0020	// File/dir is part of the original package (as opposed to files newly-added to sandbox during package use)
#define VIRT_FILE_FLAGS_STREAMED		0x0040	// File is not included in initial EXE, and is to be streamed when package runs

#define MAX_APPID_LENGTH				128

typedef struct {
	DWORD					PID;
	DWORD					Flags;
} VIRT_PROCESS;

// RUNNING_APP
typedef struct {
	DWORD					Version;
	DWORD					SerialId;
	TCHAR					CarrierExeName[MAX_PATH * 4];
	DWORD					CarrierPID;
	DWORD					StartTickTime;
	DWORD					SyncStreamingDuration;
	DWORD					TotalProcesses;
	VIRT_PROCESS			Processes[2048];
	TCHAR					AppID[MAX_APPID_LENGTH];
	TCHAR					FriendlyName[MAX_APPID_LENGTH];
} RUNNING_APP, *PRUNNING_APP;

// DEPLOYED_APP
typedef struct {
	TCHAR					AppID[MAX_APPID_LENGTH];
} DEPLOYED_APP, *PDEPLOYED_APP;

